/*A. Christidis: bi_imgGL.c - Vers. 0.0
Es fehlen (mind.): Transparenz-Darstellung, Binokularitaet, Double-Buffering
Compilieren ohne Makro WITH_TEXR macht daraus einen reinen Bildbetrachter.*/
/*Bekannte Bugs (07/2017): 
1.Umstellung auf Textur (t) / Autom. Animation (G) / Stoppen (g) 
  / Drehung um y (y) / Autom. Animation (G) => fuehrt zum "Stocken": 
  Beim Schliessen der "Textur-Tuer" verzoegert sich die Animation, weil 
  das Bild noch einmal geloescht wird.
2.Nach Groessenaenderung des Fensters passt sich der nahe Clipping-Bereich 
  (Var. close) nicht kokrrekt an.*/

#define WITH_TEXR

/*bi_imgGL.c*/
/*Laden und Darstellen von Bildern, fensterfuellend und/oder als Texturen, 
als Elemente einer Galerie <gallery[imgCount]>. Die max. <IMGNR> geladenen 
Bilder und ihre aktuellen Verarbeitungskopien liegen hinter den Zeigern 
<saveImg[imgIdx]> und <workImg[imgIdx]>.*/

#pragma warning(disable : 4996) // ("veraltet" nicht mehr melden!)

#include <conio.h>  //wg. _getch()
#include <stdio.h>  //wg. printf()
#include <stdlib.h> //wg. exit()
#include <string.h> //wg. memcpy()
#include <GL/glut.h>//wg. Konflikte: stdlib.h vor glut.h!

#include <cv.h>
#include <cxcore.h>
#include <highgui.h>

#define CON_CLS "cls"
#define ESC      27
#define CR       13
#define EPS       0.00015 
#define IMGNR     2
#define PATH    "..\\..\\_Data\\"
#define PICO    "example.bmp" //"example.jpg"//

#ifdef  WITH_TEXR
enum  {PICTURE, TEXTURE};
enum  {IMAG, SCRN};
enum  {X=0, Y=1, Z=2, W=3};
GLdouble  left=0., right=0.;
GLdouble  bottom=0., top=0., close=0., distant=0.;
GLuint    texName[IMGNR];
GLdouble  zoomX=1., zoomY=1.;
GLfloat   pos[3]={0., 0., 0.}, angle[3]={0., 0., 0.}; 
char      anim='g';
int       texFil=GL_LINEAR, winWid, winHig;
int       viewMode=PICTURE, saveMode=IMAG;
#endif//WITH_TEXR

IplImage *workImg[IMGNR], *saveImg[IMGNR];
char      gallery[][80]={"redLine256x256.bmp", "Fendi.jpg", "lena-soderberg.png", 
                         "quickBrownFoxWB.bmp", "example.bmp", 
                         "Laurel+Hardy1936sq.bmp", "Laurel+Hardy1936+1.bmp", 
                         "redcyan1s.jpg", "redcyan2.jpg", //"baboon.jpg", 
                         0}; //0: Absicherung, falls dahinter weitere char-Variablen stehen
char      imgPath[80], imgName[80];
int       imgIdx=0, imgCount=0;

/*Prototypen*/
  void draw (void);
  void key (unsigned char key, int x, int y);
  void ocv2ogl (IplImage *ocvimg);
  void prime (void);
  int saveAoI (int aoiX0, int aoiY0, int aoiWid, int aoiHig, int mode);
#ifdef  WITH_TEXR
  void animObj(int dummy);
  int checkSize (int x);
  void moveObj (void);
  void reshape (int w, int h);
  void drawTexFace (int texId);
#endif//WITH_TEXR

/*************************************************************************/
   void ocv2ogl (IplImage *ocvimg)
/*************************************************************************/
/*Converting OpenCV to OpenGL image data by rearranging the picture rows 
  bottom up and changing the color scheme from GBR to RGB*/
{ unsigned char *dummyImg=NULL;
  int            jhig=0, jwid=0, jcomp=0, ocvIdx=0, oglIdx=0;
  int            imgHig=ocvimg->height, imgWid=ocvimg->width, 
                 components=ocvimg->nChannels;

  /*Workaround: Bilder bestimmter Breiten werden verzerrt*/
  if ((imgWid*components/4)*4 != imgWid*components)
  { fprintf(stderr, "\n\n Sorry, it won't work!\n (Inappropriate picture size)"); 
    fprintf(stderr, "\n To see result, press any key in this window\n"); _getch(); }

  /*Vorerbeitung: Spaeter sollen BGR-Bilder intern als RGBA gefuehrt werden:*/
  dummyImg = (unsigned char *) malloc(imgHig * imgWid * components);
  if (!dummyImg) { fprintf(stderr, "Out of memory!\n");  _getch();  exit(1); }
  memcpy (dummyImg, ocvimg->imageData, imgHig * imgWid * components);

  for (jhig=0; jhig<imgHig; jhig++)
  { for (jwid=0; jwid<imgWid; jwid++)
    { for (jcomp=0; jcomp<components; jcomp++)
      { ocvIdx = jhig * imgWid * components + jwid * components + jcomp; 
        oglIdx = (imgHig - jhig -1)* imgWid * components + jwid* components + (components-1-jcomp);
       (ocvimg->imageData)[ocvIdx] = dummyImg[oglIdx];
      }
    }
  }
  free (dummyImg);
  return;
}

#ifdef  WITH_TEXR
/***************************************************************************/
  void reshape (int w, int h)
/***************************************************************************/
/*Pixelgroesse (zoomX x zoomY) und Fenstergroesse aktualisieren:*/
{ const  double  GRAD  = atan(1.) / 45.;

  zoomX = (GLdouble)w / workImg[imgIdx]->width;
  zoomY = (GLdouble)h / workImg[imgIdx]->height;
  glPixelZoom (zoomX, zoomY);

  /*Fenster- und Speichergroesse global aktualisieren:*/
  winWid = w;  winHig = h;

  /*Bei direkten Aufrufen: GLUT neue Fenstergroesse mitteilen:*/
  glutReshapeWindow (w, h); 

  /*Anpassung letzter Animation auf neue Fenstergroesse:*/
  pos[X]=-winWid*(1-cos(angle[Y]*GRAD))/2.;
  pos[Y]=0;
  pos[Z]=-winWid*(sin(angle[Y]*GRAD))/2.;

  /*Menue aktualisieren:*/
  key(' ', 0, 0); 
  return;
}
#endif//WITH_TEXR

/***************************************************************************/
  int saveAoI (int aoiX0, int aoiY0, int aoiWid, int aoiHig, int mode)
/***************************************************************************/
/*Speicherung eines Ausschnitts (Area of Interest) des aktuellen Fensters 
  (Teil-Screenshot)*/
{ IplImage *dumImg=NULL;

  strcpy (imgPath, PATH);  strcat (imgPath, PICO);
#ifdef  WITH_TEXR
  if (saveMode == IMAG)
  { 
#endif//WITH_TEXR
    ocv2ogl(workImg[imgIdx]); //an OpenCV anpassen
    cvSaveImage(imgPath, workImg[imgIdx], 0); //mit OpenCV speichern
    ocv2ogl(workImg[imgIdx]); //wieder an OpenGL anpassen
#ifdef  WITH_TEXR
  }
  else if (saveMode == SCRN) 
  { dumImg = cvCreateImage(cvSize(aoiWid, aoiHig), IPL_DEPTH_8U, 3);
    assert(dumImg);

    glReadPixels(aoiX0, aoiY0, aoiWid, aoiHig, GL_RGB, GL_UNSIGNED_BYTE, dumImg->imageData);
    ocv2ogl(dumImg); //an OpenCV anpassen
    cvSaveImage(imgPath, dumImg, 0); //mit OpenCV speichern
    ocv2ogl(dumImg); //wieder an OpenGL anpassen
  }
#endif//WITH_TEXR
  return (1);
}

/*************************************************************************/
  void key (unsigned char key, int x, int y)
/*************************************************************************/
{ const  double GRAD  = atan(1.) / 45.;
         int    j1=0, YesNo=0, newWid=0;
#ifdef  WITH_TEXR
         float  deltaX=winWid/10., deltaY=winHig/10., deltaZ=close/10.;
#endif//WITH_TEXR

  switch (key)
  { case ESC: for (j1=0; j1<IMGNR; j1++) {
                if (saveImg[j1]) cvReleaseImage(&saveImg[j1]);
                if (workImg[j1]) cvReleaseImage(&workImg[j1]); }
              glutDestroyWindow(1);
              exit(0);

    case CR:  cvReleaseImage(&saveImg[imgIdx]);
              cvReleaseImage(&workImg[imgIdx]);
#ifdef  WITH_TEXR
              viewMode = PICTURE; anim = 'g';
              glDeleteTextures(IMGNR, texName);
#endif//WITH_TEXR
              imgCount++;
              if (!(*gallery[imgCount])) imgCount = 0; //1. gelesenes Zeichen=0
              strcpy (imgName, gallery[imgCount]); 
              glutSetWindowTitle(imgName);
              /*Wenn nicht im aktuellen Verzeichnis, dann mit Pfad:*/
              if (!(workImg[imgIdx] = cvLoadImage(imgName, 1))) {  
              strcpy (imgPath, PATH);  strcat (imgPath, imgName);
              workImg[imgIdx] = cvLoadImage(imgPath, 1); }
              ocv2ogl(workImg[imgIdx]); 
              saveImg[imgIdx] = cvCloneImage(workImg[imgIdx]);
              glutReshapeWindow(workImg[imgIdx]->width, workImg[imgIdx]->height);
#ifdef  WITH_TEXR
             /*Erbt Endstellung letzter Animation bei neuer Bildgroesse:*/
              pos[X]=-workImg[imgIdx]->width*(1-cos(angle[Y]*GRAD))/2.;
              pos[Y]=0;
              pos[Z]=-workImg[imgIdx]->width*(sin(angle[Y]*GRAD))/2.;
#endif//WITH_TEXR
              break;

#ifdef  WITH_TEXR
    case 'A': if (viewMode == TEXTURE) pos[X] -= deltaX;  break;
#endif//WITH_TEXR

#ifdef  WITH_TEXR
    case 'c': saveMode = IMAG; 
              saveAoI (0, 0, workImg[imgIdx]->width, workImg[imgIdx]->height, saveMode);
#else //WITH_TEXR
    case 'c': 
              saveAoI (0, 0, workImg[imgIdx]->width, workImg[imgIdx]->height, 0);
#endif//WITH_TEXR
              break;

#ifdef  WITH_TEXR
    case 'D': if (viewMode == TEXTURE) pos[X] += deltaX;  break;
#endif//WITH_TEXR

#ifdef  WITH_TEXR
    case 'F': if (viewMode == TEXTURE) pos[Z] -= deltaZ;  break;
#endif//WITH_TEXR

#ifdef  WITH_TEXR
    case 'g': anim = key;  
              /*Stellung mit je nur einem glRotate und glTranslate erfassen:*/
              pos[X]=-winWid*(1-cos(angle[Y]*GRAD))/2.;
              pos[Y]=0;
              pos[Z]=-winWid*(sin(angle[Y]*GRAD))/2.;
              break; 

    case 'G': if (anim == 'G') break; else //Vermeidung mehrfacher Aufrufe 
              if (viewMode == TEXTURE) 
              { /*Das Animations-Szenario soll nur angle[Y] uebernehmen:*/
                angle[X] = angle[Z] = 0.;
                pos[X] = pos[Y] = pos[Z] = 0; 
                anim = key; 
                glMatrixMode(GL_MODELVIEW);
                glLoadIdentity(); 
                animObj(1); 
              } 
              break;  
#endif//WITH_TEXR

    case 'R': ocv2ogl(workImg[imgIdx]);
              break;

#ifdef  WITH_TEXR
    case 's': if (viewMode == TEXTURE) 
              { saveMode = SCRN;
                /*Workaround: Bilder bestimmter Breiten werden verzerrt*/
                if ((winWid * workImg[imgIdx]->nChannels / 4) * 4 != 
                     winWid * workImg[imgIdx]->nChannels)
                { fprintf(stderr, "\n\n Sorry, it won't work!"); 
                  fprintf(stderr, "\n (Inappropriate picture size)"); 
                  newWid = (1+(winWid/4))*4;
                  fprintf(stderr, "\n Reshape to %d pixels x %d lines? (y/n)\n", 
                          newWid, winHig);  YesNo=_getch(); 
                  if (YesNo == 'y') reshape (newWid, winHig);
                }
                saveAoI (0, 0, workImg[imgIdx]->width*zoomX, 
                         workImg[imgIdx]->height*zoomY, saveMode);
              } break;

    case 'S': if (viewMode == TEXTURE) pos[Y] -= deltaY;  break;
#endif//WITH_TEXR

#ifdef  WITH_TEXR
    case 't': viewMode = PICTURE + TEXTURE - viewMode;
              glClearColor(.25, .25, .25, .25);
              glClear (GL_COLOR_BUFFER_BIT);
              if (viewMode == TEXTURE)
              { glShadeModel(GL_FLAT); 
                glEnable (GL_TEXTURE_2D);  /* enable texture mapping */
                /*Einrichtung unterscheidbarer Textur-Namen (-Nummern):*/
                glGenTextures(IMGNR,texName); 
              } else
              {  glDisable (GL_TEXTURE_2D);
                anim = 'g';
                angle[X] = angle[Y] = angle[Z] = 0.;
                pos[X] = pos[Y] = pos[Z] = 0.;
              }
              break;
    case 'V': if (viewMode == TEXTURE) pos[Z] += deltaZ;  break;
    case 'W': if (viewMode == TEXTURE) pos[Y] += deltaY;  break;
    case 'x': if (viewMode == TEXTURE) angle[X] -= 5.; 
              if (angle[X] <=-360) angle[X]+=360;  
              break; 
    case 'X': if (viewMode == TEXTURE) angle[X] += 5.; 
              if (angle[X] >=+360) angle[X]-=360;  
              break; 
    case 'y': if (viewMode == TEXTURE) angle[Y] -= 5.; 
              if (angle[Y] <=-360) angle[Y]+=360;  
              break; 
    case 'Y': if (viewMode == TEXTURE) angle[Y] += 5.; 
              if (angle[Y] >=+360) angle[Y]-=360;  
              break; 
    case 'z': if (viewMode == TEXTURE) angle[Z] -= 5.; 
              if (angle[Z] <=-360) angle[Z]+=360;  
              break; 
    case 'Z': if (viewMode == TEXTURE) angle[Z] += 5.; 
              if (angle[Z] >=+360) angle[Z]-=360;  
              break; 
#endif//WITH_TEXR
  }
  draw();
  system (CON_CLS);
  printf ("\n Load/store pic with OpenCV, show/animate it with OpenGL\n");
  printf ("\n Current pic: %d x %d (%s)", workImg[imgIdx]->width, workImg[imgIdx]->height, imgName);
#ifdef  WITH_TEXR
  printf ("\n Current win: %d x %d \n",  winWid, winHig);
#endif//WITH_TEXR
  printf ("\n Keep OpenGL window active and press");
  printf ("\n<ESC> to quit ");
  printf ("\n<CR>     enter & go through gallery");

  printf ("\n c       copy current pic as '%s'", PICO);
#ifdef  WITH_TEXR
  if (viewMode == TEXTURE) 
  { printf ("\n G / g   Go/stop automatic texture animation (curr.:");
    if (anim == 'G') printf ("GO)"); else printf ("STOP)"); 
  }
#endif//WITH_TEXR

  printf ("\n R       toggle RGB(OpenGL,regular)/ BGR(OpenCV)"); 

#ifdef  WITH_TEXR
  if (viewMode == TEXTURE) 
    printf ("\n s       save current window content as '%s'", PICO); 
  printf ("\n t       toggle picture ");  if (viewMode == PICTURE) printf ("(ON)");
  printf ("/ texture "); if (viewMode == TEXTURE) printf ("(ON)");  printf (" mode"); 
  if (viewMode == TEXTURE) 
  { printf ("\n\n For moving textured face:");
    printf ("\n A / D   decrease/increase X by 10%% winWid var. (curr.: %.2f)", pos[X]);
    printf ("\n S / W   decrease/increase Y by 10%% winHig var. (curr.: %.2f)", pos[Y]);
    printf ("\n V / F   decrease/increase Z by 10%% close  var. (curr.: %.2f)", pos[Z]);
    printf ("\n x / X   decrease/increase X-rotation angle (curr.:%7.2f)", angle[X]);
    printf ("\n y / Y   decrease/increase Y-rotation angle (curr.:%7.2f)", angle[Y]);
    printf ("\n z / Z   decrease/increase Z-rotation angle (curr.:%7.2f)", angle[Z]);
  }
#endif//WITH_TEXR
  printf ("\n"); //Neue Zeile fuer Warnungen etc.
  return;
}

#ifdef  WITH_TEXR
/*************************************************************************/
  int checkSize (int x)
/*************************************************************************/
/* Make sure it's a power of 2 */
{ int j=1;

  while (j < x) j <<= 1; 
  if (j == x) return (x);
  return (0);
}

/*************************************************************************/
  void moveObj (void)
/*************************************************************************/
{ /*3D-Modell-Animation:*/
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  /*Auch ohne Animation, um EPS ins Sichtfeld verschieben:*/
  glTranslatef(0., 0., -(close+EPS)); 

  /*Automatische Animatiion:*/
  if (anim == 'G')
  { glTranslatef(-winWid/2, 0., 0.);
    glRotatef(angle[Y], 0., 1., 0.);
    glTranslatef(winWid/2, 0., 0.);
    return;
  }

  /*Parallel zu den Achsen verschieben:*/
  glTranslatef(pos[X], pos[Y], pos[Z]);

  /*Nicken(x), Gieren(y), Rollen(z) vor der Verschiebung:*/
  glRotatef(angle[Z], 0.0, 0.0, 1.0);
  glRotatef(angle[Y], 0.0, 1.0, 0.0);
  glRotatef(angle[X], 1.0, 0.0, 0.0);
}

/*************************************************************************/
  void animObj(int dummy)
/*************************************************************************/
{ static int   steps=20; //static: wechselndes Vorzeichen wiederfinden
  float open=45., shut=0.;

  glMatrixMode(GL_MODELVIEW); //entbehrlich, da schon beim Aufruf
  glLoadIdentity();
 
  if (anim == 'G') 
  { draw(); 
    if (steps > 0) //"oeffnen"
    { if (angle[Y] < open) angle[Y] += open/steps;
      else steps = -steps; 
    } else //"schliessen"
    { if (angle[Y] > shut) angle[Y] += open/steps;
      else steps = -steps;
    }

    key(' ', 0, 0); //Menue aktualisieren
    glutTimerFunc(60,animObj,1);
  }
}

/*************************************************************************/
  void drawTexFace (int texId)
/*************************************************************************/
/*Draws a rectangular face textured with image No. <texId>. Take note that 
  the texture vertex must come BEFORE the vertex that it will be assigned to. 
  Texture Coordinate Orientation
   (0,1)-------------(1,1)
     |                 |
     |     Image       |
     |                 |
     |                 |
   (0,0)-------------(1,0)
*/
{ /*Textur auf Normgroesse pruefen:*/
  if (!checkSize(workImg[imgIdx]->width) || !checkSize(workImg[imgIdx]->height))
  { printf("\nWrong texture size!\n(Should be power of 2)\n"); /*getchar()*/; }

    glBindTexture (GL_TEXTURE_2D, texName[texId]); /*bind to our texture id*/

//Diese Zeilen werden hier erwartet...
      /*Naechstgelegene Farbe oder Farbmittelung verwenden:*/
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, texFil);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, texFil);

      /*Texturfarbe deckend auftragen:*/
      glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
    //glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
//...Diese Zeilen werden hier erwartet

      /*Daten der 2D-Textur in RGB verwenden:*/
      glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, workImg[imgIdx]->width, 
                   workImg[imgIdx]->height, 
                   0, GL_RGB, GL_UNSIGNED_BYTE, workImg[imgIdx]->imageData); //_RGB != _RGBA !!

  glBegin (GL_QUADS);
    glTexCoord2f (0.0f,0.0f); /* lower left corner of image */
    glVertex3f (left, bottom, 0.);
    glTexCoord2f (1.0f, 0.0f); /* lower right corner of image */
    glVertex3f (right, bottom, 0.); 
    glTexCoord2f (1.0f, 1.0f); /* upper right corner of image */
    glVertex3f (right, top, 0.); 
    glTexCoord2f (0.0f, 1.0f); /* upper left corner of image */
    glVertex3f (left, top, 0.); 
  glEnd ();

  return;
}
#endif//WITH_TEXR

/*************************************************************************/
  void draw (void)
/*************************************************************************/
{ 
#ifdef  WITH_TEXR
  int j1=0,j2=0;
#endif//WITH_TEXR

  /*Auf alle Faelle loeschen:*/
  glClear(GL_COLOR_BUFFER_BIT);  //entbehrlich? -s. key()

#ifdef  WITH_TEXR
  if (viewMode == PICTURE) {
#endif//WITH_TEXR

    glDrawPixels(workImg[imgIdx]->width, workImg[imgIdx]->height, GL_RGB, 
                 GL_UNSIGNED_BYTE, workImg[imgIdx]->imageData);

#ifdef  WITH_TEXR
  } else if (viewMode == TEXTURE)
  {
    right  = winWid/2;  left = -right; 
    top = winHig/2.;  bottom = -top;
    close = winWid; //erzeugt fov von 53,13 Grad: 2*atg(.5)
    distant = 100.*close;//conv;
    glViewport(0, 0, winWid, winHig); 

    glMatrixMode (GL_PROJECTION);
    glLoadIdentity ();
    glFrustum (left, right, bottom, top, close, distant);

    moveObj();

    drawTexFace (imgIdx); //IMGNR-1);
  }
#endif//WITH_TEXR

glFlush();
  //glFinish(); 
  return;
}

/*************************************************************************/
  void prime (void)
/*************************************************************************/
{ strcpy (imgName, gallery[0]); 
  strcpy (imgPath, PATH);  strcat (imgPath, imgName);
  workImg[imgIdx] = cvLoadImage(imgPath, 1);  
  if (!workImg[imgIdx]) { fprintf (stderr, "\nError! Press any key to exit.\n");  
                 _getch();  exit(0); }
  /*Arbeits- und Sicherungskopie gem. OpenGL-RGB:*/
  ocv2ogl(workImg[imgIdx]); //an OpenGL anpassen
  saveImg[imgIdx] = cvCloneImage(workImg[imgIdx]); //OpenCV-untauglich

#ifdef  WITH_TEXR
  angle[X] = angle[Y] = angle[Z] = 0.;
  pos[Z] = 0; 
  winWid = workImg[imgIdx]->width; 
  winHig = workImg[imgIdx]->height;
#endif//WITH_TEXR
  key(' ', 0, 0); //Menue ausgeben
}

/*************************************************************************/
  int main (int argc, char **argv)
/*************************************************************************/
{ prime();
  glutInit(&argc, argv);                            /*Intialisierg*/
  glutInitWindowSize(workImg[imgIdx]->width, workImg[imgIdx]->height);/*Fenstergroesse*/
  glutCreateWindow(gallery[0]);                     /*Fenster-Einrichtung*/
  glutDisplayFunc (draw);                        /*Anmeldung der Callback-Funktion*/
  glutKeyboardFunc(key);                            /*Callback-Funktion fuer Tasten*/
#ifdef  WITH_TEXR
  glutReshapeFunc (reshape);                /*Callback-Funktion bei Aenderung der Festergroesse*/
#endif//WITH_TEXR
  glutMainLoop();                                   /*we never return...Start d. Ereignis-Verarbeitung durch GLUT*/ 
  return 0;
}

